#!/usr/bin/env python 

from languageClass import *

class Languages:

    def __init__(self,aLibrary=[]):
        self.library = aLibrary
        
    def read_from_file(self,aFilename):
	doc = FromXmlFile(aFilename)
	if len(doc.getElementsByTagName("languages")) == 1:
          anInstance = self.read_from_xml_tag(doc.getElementsByTagName("languages")[0])
	  return anInstance
	else: 
	  return None
    read_from_file = classmethod(read_from_file)

    def read_from_xml_tag(self, anXMLTag):
        anInstance = Languages()
        anInstance.library = []
	for aLanguageTag in anXMLTag.childNodes:
             if aLanguageTag.nodeType == Node.ELEMENT_NODE:
                 anInstance.library.append( Language.read_from_XML_tag(aLanguageTag) )
        return anInstance
    read_from_xml_tag = classmethod(read_from_xml_tag)

    def get_with_code(self, aCode):
        for aLanguage in self.library:
            if aLanguage.code == aCode:
                return aLanguage
        return None

    def get_with_label(self, aLabel):
        for aLanguage in self.library:
            if aLanguage.label == aLabel:
                return aLanguage
        return None

    def all_labels(self):
        labels = []
        for aLanguage in self.library:
            labels.append(aLanguage.label)
        return labels

    def get_all_languages_with_codes(self,allCodes):
	languages = []
	for aLanguage in self.library:
	    if aLanguage.code in allCodes:
		languages.append(aLanguage)
	return languages

    def __str__(self):
	return "%s" % self.all_labels()

